unit Viewer;

{ Program copyright (c) 1995 by Charles Calvert & Steve Teixeira }
{ Project Name: EXPLORER }

interface

uses
  WinTypes, WinProcs, SysUtils,
  Classes, Graphics,
  Forms, Controls,
  Buttons, Dialogs,
  Messages, StdCtrls, ExtCtrls;

type
  TFileViewer = class(TForm)
    ListBox1: TListBox;
    Panel1: TPanel;
    Ok: TBitBtn;
    BitBtn1: TBitBtn;
    BPrev: TBitBtn;
    BitBtn2: TBitBtn;
    BNext: TBitBtn;
    BitBtn3: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    procedure FormResize(Sender: TObject);
    procedure OkClick(Sender: TObject);
    procedure BPrevClick(Sender: TObject);
    procedure BNextClick(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormActivate(Sender: TObject);
  private
    CurNext: Integer;
  public
    FileName: String;
  end;

var
  FileViewer: TFileViewer;

implementation

{$R *.DFM}

procedure TFileViewer.FormResize(Sender: TObject);
begin
  ListBox1.Width := ClientWidth - 20;
  ListBox1.Height := ClientHeight - Panel1.Height - 15;
  Edit1.Width := (ClientWidth - 30) - Edit1.Left;
end;

procedure TFileViewer.OkClick(Sender: TObject);
begin
  Close;
end;

procedure TFileViewer.BPrevClick(Sender: TObject);
var
  Temp, i: Integer;
  S: String;
begin
  Temp := CurNext;
  CurNext := CurNext - 2;
  for i := CurNext downto 0 do begin
    S := ListBox1.Items.Strings[i];
    if Pos(LowerCase(Edit1.Text), LowerCase(S)) > 0 then begin
      ListBox1.ItemIndex := i;
      break;
    end;
  end;
  if i = 0 then begin
    MessageBox(Handle, 'Top of list', 'Not Found', mb_Ok);
    CurNext := Temp
  end else
    CurNext := i - 1;
end;

procedure TFileViewer.BNextClick(Sender: TObject);
var
  i: Integer;
  S: String;
  Temp: Integer;
begin
  Temp := CurNext;
  for i := CurNext to ListBox1.Items.Count do begin
    S := ListBox1.Items.Strings[i];
    if Pos(LowerCase(Edit1.Text), LowerCase(S)) > 0 then begin
      ListBox1.ItemIndex := i;
      break;
    end;
  end;
  if i = ListBox1.Items.Count then begin
    MessageBox(Handle, 'Bottom of List', 'Not Found', mb_Ok);
    CurNext := Temp
  end else
    CurNext := i + 1;
end;

procedure TFileViewer.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = 13 then BNextClick(nil);
end;

procedure TFileViewer.FormActivate(Sender: TObject);
var
  x, y: Integer;
begin
  CurNext := 0;
  x := GetSystemMetrics(SM_CXFullScreen);
  y := GetSystemMetrics(SM_CYFullScreen);
  BoundsRect := Rect(20, 20, x - 20, y - 20);
  Caption := 'FileView -- ' + UpperCase(FileName);
end;

end.
