unit Main;

{ Program copyright (c) 1995 by Charles Calvert }
{ Project Name: SHAPE }

interface

uses WinTypes, WinProcs, StdCtrls,
     Classes, Graphics, ExtCtrls,
     Controls, Dialogs, Forms;

type
  TForm1 = class(TForm)
    Button1: TButton;
    GroupBox1: TGroupBox;
    CircleBtn: TRadioButton;
    RectBtn: TRadioButton;
    RoundRectBtn: TRadioButton;
    ColorDialog1: TColorDialog;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure CircleBtnClick(Sender: TObject);
    procedure RectBtnClick(Sender: TObject);
    procedure RoundRectBtnClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    MyShape: TShape;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  MyShape := TShape.Create(Form1);
  MyShape.Parent := Form1;
  Button1.Enabled := False;
end;

procedure TForm1.CircleBtnClick(Sender: TObject);
begin
  if CircleBtn.Checked then 
    MyShape.Shape := StEllipse;
end;

procedure TForm1.RectBtnClick(Sender: TObject);
begin
  if RectBtn.Checked then
    MyShape.Shape := StRectangle;
end;

procedure TForm1.RoundRectBtnClick(Sender: TObject);
begin
  if RoundRectBtn.Checked then
    MyShape.Shape := StRoundRect;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if ColorDialog1.Execute then
    MyShape.Brush.Color := ColorDialog1.Color;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if ColorDialog1.Execute then
    MyShape.Pen.Color := ColorDialog1.Color;
end;

end.
